//*****************************************************************************
//
//  Author:         Kenny Kerr
//  Date created:   31 December 2005
//
//  Description:    Initializes the GDI+ library for the process.
//
//*****************************************************************************

#pragma once

namespace Kerr
{
    class AutoInitializeGdiplus
    {
    public:

        AutoInitializeGdiplus()
        {
            Gdiplus::GdiplusStartupInput input;

            GDIPLUS_VERIFY(Gdiplus::GdiplusStartup(&m_token, 
                                                   &input, 
                                                   0));
        }

        ~AutoInitializeGdiplus()
        {
            Gdiplus::GdiplusShutdown(m_token);
        }

    private:

        ULONG_PTR m_token;

    };
}
