//*****************************************************************************
//
//  Author:         Kenny Kerr
//  Date created:   31 December 2005
//
//  Description:    Automates the loading and unloading of the application's 
//                  message loop.
//
//*****************************************************************************

#pragma once

namespace Kerr
{
    class AutoMessageLoop
    {
    public:

        AutoMessageLoop()
        {
            VERIFY(_Module.AddMessageLoop(&m_loop));
        }

        ~AutoMessageLoop()
        {
            VERIFY(_Module.RemoveMessageLoop());
        }

        int Run()
        {
            return m_loop.Run();
        }

    private:

        CMessageLoop m_loop;

    };
}
