//*****************************************************************************
//
//  Author:         Kenny Kerr
//  Date created:   6 August 2006
//
//  Description:    Implements the thumbnail window for the sample. The 
//                  thumbnail window is used as the destination for the DWM
//                  thumbnail registration.
//
//*****************************************************************************

#pragma once

#include "Thumbnail.h"

class ThumbnailWindow : 
    public CWindowImpl<ThumbnailWindow, CWindow, CFrameWinTraits>
{
public:

    ThumbnailWindow();

    BEGIN_MSG_MAP(ThumbnailWindow)
        MESSAGE_HANDLER(WM_DWMCOMPOSITIONCHANGED, OnCompositionEnabled)
        MSG_WM_ERASEBKGND(OnEraseBackground)
        MSG_WM_SIZE(OnSize)
        MSG_WM_CLOSE(OnClose)
    END_MSG_MAP()

    void Create(CWindow* source,
                CRect* rect = 0);

    void Update();
    void ExcludeNcArea(bool value);

private:

    //
    // Message handlers
    //

    LRESULT OnCompositionEnabled(UINT message, WPARAM wParam, LPARAM lParam, BOOL& handled);
    bool OnEraseBackground(CDCHandle dc);
    void OnSize(UINT operation, SIZE size);
    void OnClose();

    //
    // Member variables
    //

    CWindow* m_source;
    Kerr::Thumbnail m_thumbnail;
    bool m_excludeNcArea;
};
